diff --git a/src/backend/catalog/pg_parameter_acl.c b/src/backend/catalog/pg_parameter_acl.c
index 4d2fc158a74..b61d0b315d8 100644
--- a/src/backend/catalog/pg_parameter_acl.c
+++ b/src/backend/catalog/pg_parameter_acl.c
@@ -74,7 +74,7 @@ ParameterAclCreate(const char *parameter)
 	TupleDesc	tupDesc;
 	HeapTuple	tuple;
 	Datum		values[Natts_pg_parameter_acl] = {0};
-	bool		nulls[Natts_pg_parameter_acl] = {0};
+	bool		nulls[Natts_pg_parameter_acl] = {false};
 
 	/*
 	 * To prevent cluttering pg_parameter_acl with useless entries, insist
@@ -96,12 +96,11 @@ ParameterAclCreate(const char *parameter)
 	parameterId = GetNewOidWithIndex(rel,
 									 ParameterAclOidIndexId,
 									 Anum_pg_parameter_acl_oid);
-	values[Anum_pg_parameter_acl_oid - 1] = ObjectIdGetDatum(parameterId);
-	values[Anum_pg_parameter_acl_parname - 1] =
-		PointerGetDatum(cstring_to_text(parname));
-	nulls[Anum_pg_parameter_acl_paracl - 1] = true;
+	HeapTupleSetValue(pg_parameter_acl, oid, ObjectIdGetDatum(parameterId), values);
+	HeapTupleSetValue(pg_parameter_acl, parname, PointerGetDatum(cstring_to_text(parname)), values);
+	HeapTupleSetValueNull(pg_parameter_acl, paracl, values, nulls);
 	tuple = heap_form_tuple(tupDesc, values, nulls);
-	CatalogTupleInsert(rel, tuple);
+	CatalogTupleInsert(rel, tuple, NULL);
 
 	/* Close pg_parameter_acl, but keep lock till commit. */
 	heap_freetuple(tuple);
diff --git a/src/backend/catalog/pg_proc.c b/src/backend/catalog/pg_proc.c
index acff7a0096d..c5b4a99b7ae 100644
--- a/src/backend/catalog/pg_proc.c
+++ b/src/backend/catalog/pg_proc.c
@@ -14,6 +14,7 @@
  */
 #include "postgres.h"
 
+#include "access/htup.h"
 #include "access/htup_details.h"
 #include "access/table.h"
 #include "access/xact.h"
@@ -135,9 +136,9 @@ ProcedureCreate(const char *procedureName,
 	Relation	rel;
 	HeapTuple	tup;
 	HeapTuple	oldtup;
-	bool		nulls[Natts_pg_proc];
-	Datum		values[Natts_pg_proc];
-	bool		replaces[Natts_pg_proc];
+	Datum		values[Natts_pg_proc] = {0};
+	bool		nulls[Natts_pg_proc] = {false};
+	Bitmapset  *updated = NULL;
 	NameData	procname;
 	TupleDesc	tupDesc;
 	bool		is_update;
@@ -318,67 +319,61 @@ ProcedureCreate(const char *procedureName,
 	/*
 	 * All seems OK; prepare the data to be inserted into pg_proc.
 	 */
-
-	for (i = 0; i < Natts_pg_proc; ++i)
-	{
-		nulls[i] = false;
-		values[i] = (Datum) 0;
-		replaces[i] = true;
-	}
+	HeapTupleUpdateSetAllColumnsUpdated(pg_proc, updated);
 
 	namestrcpy(&procname, procedureName);
-	values[Anum_pg_proc_proname - 1] = NameGetDatum(&procname);
-	values[Anum_pg_proc_pronamespace - 1] = ObjectIdGetDatum(procNamespace);
-	values[Anum_pg_proc_proowner - 1] = ObjectIdGetDatum(proowner);
-	values[Anum_pg_proc_prolang - 1] = ObjectIdGetDatum(languageObjectId);
-	values[Anum_pg_proc_procost - 1] = Float4GetDatum(procost);
-	values[Anum_pg_proc_prorows - 1] = Float4GetDatum(prorows);
-	values[Anum_pg_proc_provariadic - 1] = ObjectIdGetDatum(variadicType);
-	values[Anum_pg_proc_prosupport - 1] = ObjectIdGetDatum(prosupport);
-	values[Anum_pg_proc_prokind - 1] = CharGetDatum(prokind);
-	values[Anum_pg_proc_prosecdef - 1] = BoolGetDatum(security_definer);
-	values[Anum_pg_proc_proleakproof - 1] = BoolGetDatum(isLeakProof);
-	values[Anum_pg_proc_proisstrict - 1] = BoolGetDatum(isStrict);
-	values[Anum_pg_proc_proretset - 1] = BoolGetDatum(returnsSet);
-	values[Anum_pg_proc_provolatile - 1] = CharGetDatum(volatility);
-	values[Anum_pg_proc_proparallel - 1] = CharGetDatum(parallel);
-	values[Anum_pg_proc_pronargs - 1] = UInt16GetDatum(parameterCount);
-	values[Anum_pg_proc_pronargdefaults - 1] = UInt16GetDatum(list_length(parameterDefaults));
-	values[Anum_pg_proc_prorettype - 1] = ObjectIdGetDatum(returnType);
-	values[Anum_pg_proc_proargtypes - 1] = PointerGetDatum(parameterTypes);
+	HeapTupleUpdateValue(pg_proc, proname, NameGetDatum(&procname), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, pronamespace, ObjectIdGetDatum(procNamespace), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, proowner, ObjectIdGetDatum(proowner), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, prolang, ObjectIdGetDatum(languageObjectId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, procost, Float4GetDatum(procost), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, prorows, Float4GetDatum(prorows), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, provariadic, ObjectIdGetDatum(variadicType), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, prosupport, ObjectIdGetDatum(prosupport), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, prokind, CharGetDatum(prokind), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, prosecdef, BoolGetDatum(security_definer), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, proleakproof, BoolGetDatum(isLeakProof), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, proisstrict, BoolGetDatum(isStrict), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, proretset, BoolGetDatum(returnsSet), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, provolatile, CharGetDatum(volatility), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, proparallel, CharGetDatum(parallel), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, pronargs, UInt16GetDatum(parameterCount), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, pronargdefaults, UInt16GetDatum(list_length(parameterDefaults)), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, prorettype, ObjectIdGetDatum(returnType), values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, proargtypes, PointerGetDatum(parameterTypes), values, nulls, updated);
 	if (allParameterTypes != PointerGetDatum(NULL))
-		values[Anum_pg_proc_proallargtypes - 1] = allParameterTypes;
+		HeapTupleUpdateValue(pg_proc, proallargtypes, allParameterTypes, values, nulls, updated);
 	else
-		nulls[Anum_pg_proc_proallargtypes - 1] = true;
+		HeapTupleUpdateValueNull(pg_proc, proallargtypes, values, nulls, updated);
 	if (parameterModes != PointerGetDatum(NULL))
-		values[Anum_pg_proc_proargmodes - 1] = parameterModes;
+		HeapTupleUpdateValue(pg_proc, proargmodes, parameterModes, values, nulls, updated);
 	else
-		nulls[Anum_pg_proc_proargmodes - 1] = true;
+		HeapTupleUpdateValueNull(pg_proc, proargmodes, values, nulls, updated);
 	if (parameterNames != PointerGetDatum(NULL))
-		values[Anum_pg_proc_proargnames - 1] = parameterNames;
+		HeapTupleUpdateValue(pg_proc, proargnames, parameterNames, values, nulls, updated);
 	else
-		nulls[Anum_pg_proc_proargnames - 1] = true;
+		HeapTupleUpdateValueNull(pg_proc, proargnames, values, nulls, updated);
 	if (parameterDefaults != NIL)
-		values[Anum_pg_proc_proargdefaults - 1] = CStringGetTextDatum(nodeToString(parameterDefaults));
+		HeapTupleUpdateValue(pg_proc, proargdefaults, CStringGetTextDatum(nodeToString(parameterDefaults)), values, nulls, updated);
 	else
-		nulls[Anum_pg_proc_proargdefaults - 1] = true;
+		HeapTupleUpdateValueNull(pg_proc, proargdefaults, values, nulls, updated);
 	if (trftypes != PointerGetDatum(NULL))
-		values[Anum_pg_proc_protrftypes - 1] = trftypes;
+		HeapTupleUpdateValue(pg_proc, protrftypes, trftypes, values, nulls, updated);
 	else
-		nulls[Anum_pg_proc_protrftypes - 1] = true;
-	values[Anum_pg_proc_prosrc - 1] = CStringGetTextDatum(prosrc);
+		HeapTupleUpdateValueNull(pg_proc, protrftypes, values, nulls, updated);
+	HeapTupleUpdateValue(pg_proc, prosrc, CStringGetTextDatum(prosrc), values, nulls, updated);
 	if (probin)
-		values[Anum_pg_proc_probin - 1] = CStringGetTextDatum(probin);
+		HeapTupleUpdateValue(pg_proc, probin, CStringGetTextDatum(probin), values, nulls, updated);
 	else
-		nulls[Anum_pg_proc_probin - 1] = true;
+		HeapTupleUpdateValueNull(pg_proc, probin, values, nulls, updated);
 	if (prosqlbody)
-		values[Anum_pg_proc_prosqlbody - 1] = CStringGetTextDatum(nodeToString(prosqlbody));
+		HeapTupleUpdateValue(pg_proc, prosqlbody, CStringGetTextDatum(nodeToString(prosqlbody)), values, nulls, updated);
 	else
-		nulls[Anum_pg_proc_prosqlbody - 1] = true;
+		HeapTupleUpdateValueNull(pg_proc, prosqlbody, values, nulls, updated);
 	if (proconfig != PointerGetDatum(NULL))
-		values[Anum_pg_proc_proconfig - 1] = proconfig;
+		HeapTupleUpdateValue(pg_proc, proconfig, proconfig, values, nulls, updated);
 	else
-		nulls[Anum_pg_proc_proconfig - 1] = true;
+		HeapTupleUpdateValueNull(pg_proc, proconfig, values, nulls, updated);
 	/* proacl will be determined later */
 
 	rel = table_open(ProcedureRelationId, RowExclusiveLock);
@@ -579,13 +574,13 @@ ProcedureCreate(const char *procedureName,
 		 * Do not change existing oid, ownership or permissions, either.  Note
 		 * dependency-update code below has to agree with this decision.
 		 */
-		replaces[Anum_pg_proc_oid - 1] = false;
-		replaces[Anum_pg_proc_proowner - 1] = false;
-		replaces[Anum_pg_proc_proacl - 1] = false;
+		HeapTupleSetColumnNotUpdated(pg_proc, oid, updated);
+		HeapTupleSetColumnNotUpdated(pg_proc, proowner, updated);
+		HeapTupleSetColumnNotUpdated(pg_proc, proacl, updated);
 
 		/* Okay, do it... */
-		tup = heap_modify_tuple(oldtup, tupDesc, values, nulls, replaces);
-		CatalogTupleUpdate(rel, &tup->t_self, tup);
+		tup = heap_update_tuple(oldtup, tupDesc, values, nulls, updated);
+		CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 
 		ReleaseSysCache(oldtup);
 		is_update = true;
@@ -599,18 +594,23 @@ ProcedureCreate(const char *procedureName,
 		proacl = get_user_default_acl(OBJECT_FUNCTION, proowner,
 									  procNamespace);
 		if (proacl != NULL)
-			values[Anum_pg_proc_proacl - 1] = PointerGetDatum(proacl);
+			HeapTupleUpdateValue(pg_proc, proacl, PointerGetDatum(proacl), values, nulls, updated);
 		else
-			nulls[Anum_pg_proc_proacl - 1] = true;
+			HeapTupleUpdateValueNull(pg_proc, proacl, values, nulls, updated);
 
 		newOid = GetNewOidWithIndex(rel, ProcedureOidIndexId,
 									Anum_pg_proc_oid);
-		values[Anum_pg_proc_oid - 1] = ObjectIdGetDatum(newOid);
+		HeapTupleUpdateValue(pg_proc, oid, ObjectIdGetDatum(newOid), values, nulls, updated);
+
+		/* Okay, do it... */
 		tup = heap_form_tuple(tupDesc, values, nulls);
-		CatalogTupleInsert(rel, tup);
+		CatalogTupleInsert(rel, tup, NULL);
+
 		is_update = false;
 	}
 
+	bms_free(updated);
+	updated = NULL;
 
 	retval = ((Form_pg_proc) GETSTRUCT(tup))->oid;
 
diff --git a/src/backend/catalog/pg_publication.c b/src/backend/catalog/pg_publication.c
index 9a4791c573e..08cfee44f8f 100644
--- a/src/backend/catalog/pg_publication.c
+++ b/src/backend/catalog/pg_publication.c
@@ -433,8 +433,8 @@ publication_add_relation(Oid pubid, PublicationRelInfo *pri,
 {
 	Relation	rel;
 	HeapTuple	tup;
-	Datum		values[Natts_pg_publication_rel];
-	bool		nulls[Natts_pg_publication_rel];
+	Datum		values[Natts_pg_publication_rel] = {0};
+	bool		nulls[Natts_pg_publication_rel] = {false};
 	Relation	targetrel = pri->relation;
 	Oid			relid = RelationGetRelid(targetrel);
 	Oid			pubreloid;
@@ -477,28 +477,26 @@ publication_add_relation(Oid pubid, PublicationRelInfo *pri,
 
 	pubreloid = GetNewOidWithIndex(rel, PublicationRelObjectIndexId,
 								   Anum_pg_publication_rel_oid);
-	values[Anum_pg_publication_rel_oid - 1] = ObjectIdGetDatum(pubreloid);
-	values[Anum_pg_publication_rel_prpubid - 1] =
-		ObjectIdGetDatum(pubid);
-	values[Anum_pg_publication_rel_prrelid - 1] =
-		ObjectIdGetDatum(relid);
+	HeapTupleSetValue(pg_publication_rel, oid, ObjectIdGetDatum(pubreloid), values);
+	HeapTupleSetValue(pg_publication_rel, prpubid, ObjectIdGetDatum(pubid), values);
+	HeapTupleSetValue(pg_publication_rel, prrelid, ObjectIdGetDatum(relid), values);
 
 	/* Add qualifications, if available */
 	if (pri->whereClause != NULL)
-		values[Anum_pg_publication_rel_prqual - 1] = CStringGetTextDatum(nodeToString(pri->whereClause));
+		HeapTupleSetValue(pg_publication_rel, prqual, CStringGetTextDatum(nodeToString(pri->whereClause)), values);
 	else
-		nulls[Anum_pg_publication_rel_prqual - 1] = true;
+		HeapTupleSetValueNull(pg_publication_rel, prqual, values, nulls);
 
 	/* Add column list, if available */
 	if (pri->columns)
-		values[Anum_pg_publication_rel_prattrs - 1] = PointerGetDatum(attnumstoint2vector(attnums));
+		HeapTupleSetValue(pg_publication_rel, prattrs, PointerGetDatum(attnumstoint2vector(attnums)), values);
 	else
-		nulls[Anum_pg_publication_rel_prattrs - 1] = true;
+		HeapTupleSetValueNull(pg_publication_rel, prattrs, values, nulls);
 
 	tup = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 
 	/* Insert tuple into catalog. */
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 	heap_freetuple(tup);
 
 	/* Register dependencies as needed */
@@ -674,8 +672,8 @@ publication_add_schema(Oid pubid, Oid schemaid, bool if_not_exists)
 {
 	Relation	rel;
 	HeapTuple	tup;
-	Datum		values[Natts_pg_publication_namespace];
-	bool		nulls[Natts_pg_publication_namespace];
+	Datum		values[Natts_pg_publication_namespace] = {0};
+	bool		nulls[Natts_pg_publication_namespace] = {false};
 	Oid			psschid;
 	Publication *pub = GetPublication(pubid);
 	List	   *schemaRels = NIL;
@@ -712,16 +710,14 @@ publication_add_schema(Oid pubid, Oid schemaid, bool if_not_exists)
 
 	psschid = GetNewOidWithIndex(rel, PublicationNamespaceObjectIndexId,
 								 Anum_pg_publication_namespace_oid);
-	values[Anum_pg_publication_namespace_oid - 1] = ObjectIdGetDatum(psschid);
-	values[Anum_pg_publication_namespace_pnpubid - 1] =
-		ObjectIdGetDatum(pubid);
-	values[Anum_pg_publication_namespace_pnnspid - 1] =
-		ObjectIdGetDatum(schemaid);
+	HeapTupleSetValue(pg_publication_namespace, oid, ObjectIdGetDatum(psschid), values);
+	HeapTupleSetValue(pg_publication_namespace, pnpubid, ObjectIdGetDatum(pubid), values);
+	HeapTupleSetValue(pg_publication_namespace, pnnspid, ObjectIdGetDatum(schemaid), values);
 
 	tup = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 
 	/* Insert tuple into catalog */
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 	heap_freetuple(tup);
 
 	ObjectAddressSet(myself, PublicationNamespaceRelationId, psschid);
diff --git a/src/backend/catalog/pg_range.c b/src/backend/catalog/pg_range.c
index cd21c84c8fd..0e6a5b27501 100644
--- a/src/backend/catalog/pg_range.c
+++ b/src/backend/catalog/pg_range.c
@@ -38,8 +38,8 @@ RangeCreate(Oid rangeTypeOid, Oid rangeSubType, Oid rangeCollation,
 			RegProcedure rangeSubDiff, Oid multirangeTypeOid)
 {
 	Relation	pg_range;
-	Datum		values[Natts_pg_range];
-	bool		nulls[Natts_pg_range];
+	Datum		values[Natts_pg_range] = {0};
+	bool		nulls[Natts_pg_range] = {false};
 	HeapTuple	tup;
 	ObjectAddress myself;
 	ObjectAddress referenced;
@@ -50,17 +50,17 @@ RangeCreate(Oid rangeTypeOid, Oid rangeSubType, Oid rangeCollation,
 
 	memset(nulls, 0, sizeof(nulls));
 
-	values[Anum_pg_range_rngtypid - 1] = ObjectIdGetDatum(rangeTypeOid);
-	values[Anum_pg_range_rngsubtype - 1] = ObjectIdGetDatum(rangeSubType);
-	values[Anum_pg_range_rngcollation - 1] = ObjectIdGetDatum(rangeCollation);
-	values[Anum_pg_range_rngsubopc - 1] = ObjectIdGetDatum(rangeSubOpclass);
-	values[Anum_pg_range_rngcanonical - 1] = ObjectIdGetDatum(rangeCanonical);
-	values[Anum_pg_range_rngsubdiff - 1] = ObjectIdGetDatum(rangeSubDiff);
-	values[Anum_pg_range_rngmultitypid - 1] = ObjectIdGetDatum(multirangeTypeOid);
+	HeapTupleSetValue(pg_range, rngtypid, ObjectIdGetDatum(rangeTypeOid), values);
+	HeapTupleSetValue(pg_range, rngsubtype, ObjectIdGetDatum(rangeSubType), values);
+	HeapTupleSetValue(pg_range, rngcollation, ObjectIdGetDatum(rangeCollation), values);
+	HeapTupleSetValue(pg_range, rngsubopc, ObjectIdGetDatum(rangeSubOpclass), values);
+	HeapTupleSetValue(pg_range, rngcanonical, ObjectIdGetDatum(rangeCanonical), values);
+	HeapTupleSetValue(pg_range, rngsubdiff, ObjectIdGetDatum(rangeSubDiff), values);
+	HeapTupleSetValue(pg_range, rngmultitypid, ObjectIdGetDatum(multirangeTypeOid), values);
 
 	tup = heap_form_tuple(RelationGetDescr(pg_range), values, nulls);
 
-	CatalogTupleInsert(pg_range, tup);
+	CatalogTupleInsert(pg_range, tup, NULL);
 	heap_freetuple(tup);
 
 	/* record type's dependencies on range-related items */
diff --git a/src/backend/catalog/pg_shdepend.c b/src/backend/catalog/pg_shdepend.c
index 3db41ecd74f..e926d0fcbd7 100644
--- a/src/backend/catalog/pg_shdepend.c
+++ b/src/backend/catalog/pg_shdepend.c
@@ -266,38 +266,41 @@ shdepChangeDep(Relation sdepRel,
 	}
 	else if (oldtup)
 	{
+		Bitmapset  *updated = NULL;
+
 		/* Need to update existing entry */
 		Form_pg_shdepend shForm = (Form_pg_shdepend) GETSTRUCT(oldtup);
 
 		/* Since oldtup is a copy, we can just modify it in-memory */
 		shForm->refclassid = refclassid;
+		HeapTupleMarkColumnUpdated(pg_shdepend, refclassid, updated);
 		shForm->refobjid = refobjid;
+		HeapTupleMarkColumnUpdated(pg_shdepend, refobjid, updated);
 
-		CatalogTupleUpdate(sdepRel, &oldtup->t_self, oldtup);
+		CatalogTupleUpdate(sdepRel, &oldtup->t_self, oldtup, updated, NULL);
+		bms_free(updated);
 	}
 	else
 	{
 		/* Need to insert new entry */
-		Datum		values[Natts_pg_shdepend];
-		bool		nulls[Natts_pg_shdepend];
-
-		memset(nulls, false, sizeof(nulls));
+		Datum		values[Natts_pg_shdepend] = {0};
+		bool		nulls[Natts_pg_shdepend] = {false};
 
-		values[Anum_pg_shdepend_dbid - 1] = ObjectIdGetDatum(dbid);
-		values[Anum_pg_shdepend_classid - 1] = ObjectIdGetDatum(classid);
-		values[Anum_pg_shdepend_objid - 1] = ObjectIdGetDatum(objid);
-		values[Anum_pg_shdepend_objsubid - 1] = Int32GetDatum(objsubid);
+		HeapTupleSetValue(pg_shdepend, dbid, ObjectIdGetDatum(dbid), values);
+		HeapTupleSetValue(pg_shdepend, classid, ObjectIdGetDatum(classid), values);
+		HeapTupleSetValue(pg_shdepend, objid, ObjectIdGetDatum(objid), values);
+		HeapTupleSetValue(pg_shdepend, objsubid, Int32GetDatum(objsubid), values);
 
-		values[Anum_pg_shdepend_refclassid - 1] = ObjectIdGetDatum(refclassid);
-		values[Anum_pg_shdepend_refobjid - 1] = ObjectIdGetDatum(refobjid);
-		values[Anum_pg_shdepend_deptype - 1] = CharGetDatum(deptype);
+		HeapTupleSetValue(pg_shdepend, refclassid, ObjectIdGetDatum(refclassid), values);
+		HeapTupleSetValue(pg_shdepend, refobjid, ObjectIdGetDatum(refobjid), values);
+		HeapTupleSetValue(pg_shdepend, deptype, CharGetDatum(deptype), values);
 
 		/*
 		 * we are reusing oldtup just to avoid declaring a new variable, but
 		 * it's certainly a new tuple
 		 */
 		oldtup = heap_form_tuple(RelationGetDescr(sdepRel), values, nulls);
-		CatalogTupleInsert(sdepRel, oldtup);
+		CatalogTupleInsert(sdepRel, oldtup, NULL);
 	}
 
 	if (oldtup)
@@ -955,13 +958,13 @@ copyTemplateDependencies(Oid templateDbId, Oid newDbId)
 
 		shdep = (Form_pg_shdepend) GETSTRUCT(tup);
 
-		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_dbid - 1] = ObjectIdGetDatum(newDbId);
-		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_classid - 1] = ObjectIdGetDatum(shdep->classid);
-		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_objid - 1] = ObjectIdGetDatum(shdep->objid);
-		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_objsubid - 1] = Int32GetDatum(shdep->objsubid);
-		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_refclassid - 1] = ObjectIdGetDatum(shdep->refclassid);
-		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_refobjid - 1] = ObjectIdGetDatum(shdep->refobjid);
-		slot[slot_stored_count]->tts_values[Anum_pg_shdepend_deptype - 1] = CharGetDatum(shdep->deptype);
+		HeapTupleSetValue(pg_shdepend, dbid, ObjectIdGetDatum(newDbId), slot[slot_stored_count]->tts_values);
+		HeapTupleSetValue(pg_shdepend, classid, ObjectIdGetDatum(shdep->classid), slot[slot_stored_count]->tts_values);
+		HeapTupleSetValue(pg_shdepend, objid, ObjectIdGetDatum(shdep->objid), slot[slot_stored_count]->tts_values);
+		HeapTupleSetValue(pg_shdepend, objsubid, Int32GetDatum(shdep->objsubid), slot[slot_stored_count]->tts_values);
+		HeapTupleSetValue(pg_shdepend, refclassid, ObjectIdGetDatum(shdep->refclassid), slot[slot_stored_count]->tts_values);
+		HeapTupleSetValue(pg_shdepend, refobjid, ObjectIdGetDatum(shdep->refobjid), slot[slot_stored_count]->tts_values);
+		HeapTupleSetValue(pg_shdepend, deptype, CharGetDatum(shdep->deptype), slot[slot_stored_count]->tts_values);
 
 		ExecStoreVirtualTuple(slot[slot_stored_count]);
 		slot_stored_count++;
@@ -969,14 +972,14 @@ copyTemplateDependencies(Oid templateDbId, Oid newDbId)
 		/* If slots are full, insert a batch of tuples */
 		if (slot_stored_count == max_slots)
 		{
-			CatalogTuplesMultiInsertWithInfo(sdepRel, slot, slot_stored_count, indstate);
+			CatalogTuplesMultiInsert(sdepRel, slot, slot_stored_count, indstate);
 			slot_stored_count = 0;
 		}
 	}
 
 	/* Insert any tuples left in the buffer */
 	if (slot_stored_count > 0)
-		CatalogTuplesMultiInsertWithInfo(sdepRel, slot, slot_stored_count, indstate);
+		CatalogTuplesMultiInsert(sdepRel, slot, slot_stored_count, indstate);
 
 	systable_endscan(scan);
 
@@ -1072,8 +1075,8 @@ shdepAddDependency(Relation sdepRel,
 				   SharedDependencyType deptype)
 {
 	HeapTuple	tup;
-	Datum		values[Natts_pg_shdepend];
-	bool		nulls[Natts_pg_shdepend];
+	Datum		values[Natts_pg_shdepend] = {0};
+	bool		nulls[Natts_pg_shdepend] = {false};
 
 	/*
 	 * Make sure the object doesn't go away while we record the dependency on
@@ -1087,18 +1090,18 @@ shdepAddDependency(Relation sdepRel,
 	/*
 	 * Form the new tuple and record the dependency.
 	 */
-	values[Anum_pg_shdepend_dbid - 1] = ObjectIdGetDatum(classIdGetDbId(classId));
-	values[Anum_pg_shdepend_classid - 1] = ObjectIdGetDatum(classId);
-	values[Anum_pg_shdepend_objid - 1] = ObjectIdGetDatum(objectId);
-	values[Anum_pg_shdepend_objsubid - 1] = Int32GetDatum(objsubId);
+	HeapTupleSetValue(pg_shdepend, dbid, ObjectIdGetDatum(classIdGetDbId(classId)), values);
+	HeapTupleSetValue(pg_shdepend, classid, ObjectIdGetDatum(classId), values);
+	HeapTupleSetValue(pg_shdepend, objid, ObjectIdGetDatum(objectId), values);
+	HeapTupleSetValue(pg_shdepend, objsubid, Int32GetDatum(objsubId), values);
 
-	values[Anum_pg_shdepend_refclassid - 1] = ObjectIdGetDatum(refclassId);
-	values[Anum_pg_shdepend_refobjid - 1] = ObjectIdGetDatum(refobjId);
-	values[Anum_pg_shdepend_deptype - 1] = CharGetDatum(deptype);
+	HeapTupleSetValue(pg_shdepend, refclassid, ObjectIdGetDatum(refclassId), values);
+	HeapTupleSetValue(pg_shdepend, refobjid, ObjectIdGetDatum(refobjId), values);
+	HeapTupleSetValue(pg_shdepend, deptype, CharGetDatum(deptype), values);
 
 	tup = heap_form_tuple(sdepRel->rd_att, values, nulls);
 
-	CatalogTupleInsert(sdepRel, tup);
+	CatalogTupleInsert(sdepRel, tup, NULL);
 
 	/* clean up */
 	heap_freetuple(tup);
diff --git a/src/backend/catalog/pg_subscription.c b/src/backend/catalog/pg_subscription.c
index 2b103245290..ffb0e422f7d 100644
--- a/src/backend/catalog/pg_subscription.c
+++ b/src/backend/catalog/pg_subscription.c
@@ -203,9 +203,9 @@ void
 DisableSubscription(Oid subid)
 {
 	Relation	rel;
-	bool		nulls[Natts_pg_subscription];
-	bool		replaces[Natts_pg_subscription];
-	Datum		values[Natts_pg_subscription];
+	Datum		values[Natts_pg_subscription] = {0};
+	bool		nulls[Natts_pg_subscription] = {false};
+	Bitmapset  *updated = NULL;
 	HeapTuple	tup;
 
 	/* Look up the subscription in the catalog */
@@ -217,19 +217,13 @@ DisableSubscription(Oid subid)
 
 	LockSharedObject(SubscriptionRelationId, subid, 0, AccessShareLock);
 
-	/* Form a new tuple. */
-	memset(values, 0, sizeof(values));
-	memset(nulls, false, sizeof(nulls));
-	memset(replaces, false, sizeof(replaces));
-
 	/* Set the subscription to disabled. */
-	values[Anum_pg_subscription_subenabled - 1] = BoolGetDatum(false);
-	replaces[Anum_pg_subscription_subenabled - 1] = true;
+	HeapTupleUpdateValue(pg_subscription, subenabled, BoolGetDatum(false), values, nulls, updated);
 
 	/* Update the catalog */
-	tup = heap_modify_tuple(tup, RelationGetDescr(rel), values, nulls,
-							replaces);
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	tup = heap_update_tuple(tup, RelationGetDescr(rel), values, nulls, updated);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
+	bms_free(updated);
 	heap_freetuple(tup);
 
 	table_close(rel, NoLock);
@@ -272,8 +266,8 @@ AddSubscriptionRelState(Oid subid, Oid relid, char state,
 {
 	Relation	rel;
 	HeapTuple	tup;
-	bool		nulls[Natts_pg_subscription_rel];
-	Datum		values[Natts_pg_subscription_rel];
+	Datum		values[Natts_pg_subscription_rel] = {0};
+	bool		nulls[Natts_pg_subscription_rel] = {false};
 
 	LockSharedObject(SubscriptionRelationId, subid, 0, AccessShareLock);
 
@@ -288,20 +282,18 @@ AddSubscriptionRelState(Oid subid, Oid relid, char state,
 			 relid, subid);
 
 	/* Form the tuple. */
-	memset(values, 0, sizeof(values));
-	memset(nulls, false, sizeof(nulls));
-	values[Anum_pg_subscription_rel_srsubid - 1] = ObjectIdGetDatum(subid);
-	values[Anum_pg_subscription_rel_srrelid - 1] = ObjectIdGetDatum(relid);
-	values[Anum_pg_subscription_rel_srsubstate - 1] = CharGetDatum(state);
+	HeapTupleSetValue(pg_subscription_rel, srsubid, ObjectIdGetDatum(subid), values);
+	HeapTupleSetValue(pg_subscription_rel, srrelid, ObjectIdGetDatum(relid), values);
+	HeapTupleSetValue(pg_subscription_rel, srsubstate, CharGetDatum(state), values);
 	if (XLogRecPtrIsValid(sublsn))
-		values[Anum_pg_subscription_rel_srsublsn - 1] = LSNGetDatum(sublsn);
+		HeapTupleSetValue(pg_subscription_rel, srsublsn, LSNGetDatum(sublsn), values);
 	else
-		nulls[Anum_pg_subscription_rel_srsublsn - 1] = true;
+		HeapTupleSetValueNull(pg_subscription_rel, srsublsn, values, nulls);
 
 	tup = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 
 	/* Insert tuple into catalog. */
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 
 	heap_freetuple(tup);
 
@@ -326,9 +318,9 @@ UpdateSubscriptionRelState(Oid subid, Oid relid, char state,
 {
 	Relation	rel;
 	HeapTuple	tup;
-	bool		nulls[Natts_pg_subscription_rel];
-	Datum		values[Natts_pg_subscription_rel];
-	bool		replaces[Natts_pg_subscription_rel];
+	Datum		values[Natts_pg_subscription_rel] = {0};
+	bool		nulls[Natts_pg_subscription_rel] = {false};
+	Bitmapset  *updated = NULL;
 
 	if (already_locked)
 	{
@@ -358,27 +350,21 @@ UpdateSubscriptionRelState(Oid subid, Oid relid, char state,
 			 relid, subid);
 
 	/* Update the tuple. */
-	memset(values, 0, sizeof(values));
-	memset(nulls, false, sizeof(nulls));
-	memset(replaces, false, sizeof(replaces));
-
-	replaces[Anum_pg_subscription_rel_srsubstate - 1] = true;
-	values[Anum_pg_subscription_rel_srsubstate - 1] = CharGetDatum(state);
+	HeapTupleUpdateValue(pg_subscription_rel, srsubstate, CharGetDatum(state), values, nulls, updated);
 
-	replaces[Anum_pg_subscription_rel_srsublsn - 1] = true;
 	if (XLogRecPtrIsValid(sublsn))
-		values[Anum_pg_subscription_rel_srsublsn - 1] = LSNGetDatum(sublsn);
+		HeapTupleUpdateValue(pg_subscription_rel, srsublsn, LSNGetDatum(sublsn), values, nulls, updated);
 	else
-		nulls[Anum_pg_subscription_rel_srsublsn - 1] = true;
+		HeapTupleUpdateValueNull(pg_subscription_rel, srsublsn, values, nulls, updated);
 
-	tup = heap_modify_tuple(tup, RelationGetDescr(rel), values, nulls,
-							replaces);
+	tup = heap_update_tuple(tup, RelationGetDescr(rel), values, nulls, updated);
 
 	/* Update the catalog. */
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 
 	/* Cleanup. */
 	table_close(rel, NoLock);
+	bms_free(updated);
 }
 
 /*
@@ -645,9 +631,9 @@ void
 UpdateDeadTupleRetentionStatus(Oid subid, bool active)
 {
 	Relation	rel;
-	bool		nulls[Natts_pg_subscription];
-	bool		replaces[Natts_pg_subscription];
-	Datum		values[Natts_pg_subscription];
+	Datum		values[Natts_pg_subscription] = {0};
+	bool		nulls[Natts_pg_subscription] = {false};
+	Bitmapset  *updated = NULL;
 	HeapTuple	tup;
 
 	/* Look up the subscription in the catalog */
@@ -659,20 +645,16 @@ UpdateDeadTupleRetentionStatus(Oid subid, bool active)
 
 	LockSharedObject(SubscriptionRelationId, subid, 0, AccessShareLock);
 
-	/* Form a new tuple. */
-	memset(values, 0, sizeof(values));
-	memset(nulls, false, sizeof(nulls));
-	memset(replaces, false, sizeof(replaces));
-
 	/* Set the subscription to disabled. */
-	values[Anum_pg_subscription_subretentionactive - 1] = active;
-	replaces[Anum_pg_subscription_subretentionactive - 1] = true;
+	HeapTupleUpdateValue(pg_subscription, subretentionactive, active, values, nulls, updated);
 
 	/* Update the catalog */
-	tup = heap_modify_tuple(tup, RelationGetDescr(rel), values, nulls,
-							replaces);
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
-	heap_freetuple(tup);
+	tup = heap_update_tuple(tup, RelationGetDescr(rel), values, nulls, updated);
 
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
+
+	/* Cleanup */
+	bms_free(updated);
+	heap_freetuple(tup);
 	table_close(rel, NoLock);
 }
